/* © 2019-2024, <@JeanLucasMCPE> - All Rights Reserved. */

import { system, world } from '@minecraft/server';

class Compostables {
  static registerCompostables = [
    { "item": "minecraft:sugar", "chance": 0.1 },
    { "item": "minecraft:honeycomb", "chance": 0.1 },
    { "item": "minecraft:spider_eye", "chance": 0.1 },
    { "item": "minecraft:fermented_spider_eye", "chance": 0.1 },
    { "item": "minecraft:phantom_membrane", "chance": 0.1 },
    { "item": "minecraft:scute", "chance": 0.1 },
    { "item": "minecraft:rabbit_hide", "chance": 0.1 },
    { "item": "minecraft:bamboo", "chance": 0.1 },
    { "item": "minecraft:string", "chance": 0.1 },
    { "item": "minecraft:feather", "chance": 0.1 },
    { "item": "minecraft:slime_ball", "chance": 0.1 },
    { "item": "minecraft:magma_cream", "chance": 0.1 },
    { "item": "minecraft:ink_sac", "chance": 0.1 },
    { "item": "minecraft:glow_ink_sac", "chance": 0.1 },
    { "item": "minecraft:black_dye", "chance": 0.1 },
    { "item": "minecraft:red_dye", "chance": 0.1 },
    { "item": "minecraft:green_dye", "chance": 0.1 },
    { "item": "minecraft:brown_dye", "chance": 0.1 },
    { "item": "minecraft:blue_dye", "chance": 0.1 },
    { "item": "minecraft:purple_dye", "chance": 0.1 },
    { "item": "minecraft:cyan_dye", "chance": 0.1 },
    { "item": "minecraft:light_gray_dye", "chance": 0.1 },
    { "item": "minecraft:gray_dye", "chance": 0.1 },
    { "item": "minecraft:pink_dye", "chance": 0.1 },
    { "item": "minecraft:lime_dye", "chance": 0.1 },
    { "item": "minecraft:yellow_dye", "chance": 0.1 },
    { "item": "minecraft:light_blue_dye", "chance": 0.1 },
    { "item": "minecraft:magenta_dye", "chance": 0.1 },
    { "item": "minecraft:orange_dye", "chance": 0.1 },
    { "item": "minecraft:white_dye", "chance": 0.1 },
    { "item": "minecraft:stick", "chance": 0.1 },
    { "item": "minecraft:white_carpet", "chance": 0.1 },
    { "item": "minecraft:orange_carpet", "chance": 0.1 },
    { "item": "minecraft:magenta_carpet", "chance": 0.1 },
    { "item": "minecraft:light_blue_carpet", "chance": 0.1 },
    { "item": "minecraft:yellow_carpet", "chance": 0.1 },
    { "item": "minecraft:lime_carpet", "chance": 0.1 },
    { "item": "minecraft:pink_carpet", "chance": 0.1 },
    { "item": "minecraft:gray_carpet", "chance": 0.1 },
    { "item": "minecraft:light_gray_carpet", "chance": 0.1 },
    { "item": "minecraft:cyan_carpet", "chance": 0.1 },
    { "item": "minecraft:purple_carpet", "chance": 0.1 },
    { "item": "minecraft:blue_carpet", "chance": 0.1 },
    { "item": "minecraft:brown_carpet", "chance": 0.1 },
    { "item": "minecraft:green_carpet", "chance": 0.1 },
    { "item": "minecraft:red_carpet", "chance": 0.1 },
    { "item": "minecraft:black_carpet", "chance": 0.1 },
    { "item": "minecraft:chorus_fruit", "chance": 0.3 },
    { "item": "minecraft:popped_chorus_fruit", "chance": 0.3 },
    { "item": "minecraft:chorus_flower", "chance": 0.3 },
    { "item": "minecraft:honey_block", "chance": 0.3 },
    { "item": "minecraft:honeycomb_block", "chance": 0.3 },
    { "item": "minecraft:rotten_flesh", "chance": 0.3 },
    { "item": "minecraft:egg", "chance": 0.3 },
    { "item": "minecraft:turtle_egg", "chance": 0.3 },
    { "item": "minecraft:sniffer_egg", "chance": 0.3 },
    { "item": "minecraft:leather", "chance": 0.3 },
    { "item": "minecraft:deadbush", "chance": 0.3 },
    { "item": "minecraft:charcoal", "chance": 0.3 },
    { "item": "minecraft:white_wool", "chance": 0.3 },
    { "item": "minecraft:orange_wool", "chance": 0.3 },
    { "item": "minecraft:magenta_wool", "chance": 0.3 },
    { "item": "minecraft:light_blue_wool", "chance": 0.3 },
    { "item": "minecraft:yellow_wool", "chance": 0.3 },
    { "item": "minecraft:lime_wool", "chance": 0.3 },
    { "item": "minecraft:pink_wool", "chance": 0.3 },
    { "item": "minecraft:gray_wool", "chance": 0.3 },
    { "item": "minecraft:light_gray_wool", "chance": 0.3 },
    { "item": "minecraft:cyan_wool", "chance": 0.3 },
    { "item": "minecraft:purple_wool", "chance": 0.3 },
    { "item": "minecraft:blue_wool", "chance": 0.3 },
    { "item": "minecraft:brown_wool", "chance": 0.3 },
    { "item": "minecraft:green_wool", "chance": 0.3 },
    { "item": "minecraft:red_wool", "chance": 0.3 },
    { "item": "minecraft:black_wool", "chance": 0.3 },
    { "item": "minecraft:slime", "chance": 0.3 },
    { "item": "minecraft:nautilus_shell", "chance": 0.3 },
    { "item": "minecraft:paper", "chance": 0.3 },
    { "item": "minecraft:web", "chance": 0.3 },
    { "item": "minecraft:goat_horn", "chance": 0.3 },
    { "item": "minecraft:muddy_mangrove_roots", "chance": 0.3 },
    { "item": "minecraft:cooked_beef", "chance": 0.5 },
    { "item": "minecraft:cooked_chicken", "chance": 0.5 },
    { "item": "minecraft:cooked_cod", "chance": 0.5 },
    { "item": "minecraft:cooked_mutton", "chance": 0.5 },
    { "item": "minecraft:cooked_porkchop", "chance": 0.5 },
    { "item": "minecraft:cooked_rabbit", "chance": 0.5 },
    { "item": "minecraft:cooked_salmon", "chance": 0.5 },
    { "item": "minecraft:beef", "chance": 0.5 },
    { "item": "minecraft:chicken", "chance": 0.5 },
    { "item": "minecraft:cod", "chance": 0.5 },
    { "item": "minecraft:mutton", "chance": 0.5 },
    { "item": "minecraft:porkchop", "chance": 0.5 },
    { "item": "minecraft:rabbit", "chance": 0.5 },
    { "item": "minecraft:rabbit_foot", "chance": 0.5 },
    { "item": "minecraft:salmon", "chance": 0.5 },
    { "item": "minecraft:tropical_fish", "chance": 0.5 },
    { "item": "minecraft:pufferfish", "chance": 0.5 },
    { "item": "minecraft:crimson_nylium", "chance": 0.5 },
    { "item": "minecraft:warped_nylium", "chance": 0.5 },
    { "item": "minecraft:poisonous_potato", "chance": 0.65 },
    { "item": "minecraft:tube_coral", "chance": 0.65 },
    { "item": "minecraft:brain_coral", "chance": 0.65 },
    { "item": "minecraft:bubble_coral", "chance": 0.65 },
    { "item": "minecraft:fire_coral", "chance": 0.65 },
    { "item": "minecraft:horn_coral", "chance": 0.65 },
    { "item": "minecraft:dead_tube_coral", "chance": 0.65 },
    { "item": "minecraft:dead_brain_coral", "chance": 0.65 },
    { "item": "minecraft:dead_bubble_coral", "chance": 0.65 },
    { "item": "minecraft:dead_fire_coral", "chance": 0.65 },
    { "item": "minecraft:dead_horn_coral", "chance": 0.65 },
    { "item": "minecraft:coral_fan", "chance": 0.65 },
    { "item": "minecraft:coral_fan_dead", "chance": 0.65 },
    { "item": "minecraft:beehive", "chance": 0.65 },
    { "item": "minecraft:bee_nest", "chance": 0.65 },
    { "item": "minecraft:beetroot_soup", "chance": 0.85 },
    { "item": "minecraft:mushroom_stew", "chance": 0.85 },
    { "item": "minecraft:rabbit_stew", "chance": 0.85 },
    { "item": "minecraft:suspicious_stew", "chance": 0.85 },
    { "item": "minecraft:coral_block", "chance": 0.85 },
    { "item": "minecraft:sculk_vein", "chance": 0.85 },
    { "item": "minecraft:mycelium", "chance": 1.0 },
    { "item": "minecraft:sculk", "chance": 1.0 },
    { "item": "minecraft:sculk_catalyst", "chance": 1.0 },
    { "item": "minecraft:sculk_shrieker", "chance": 1.0 },
    { "item": "minecraft:sculk_sensor", "chance": 1.0 }
  ]
  static vanillaCompostables = [
    { "item": "minecraft:beetroot_seeds", "chance": 0.3 },
    { "item": "minecraft:dried_kelp", "chance": 0.3 },
    { "item": "minecraft:glow_berries", "chance": 0.3 },
    { "item": "minecraft:tallgrass", "chance": 0.3 },
    { "item": "minecraft:grass", "chance": 0.3 },
    { "item": "minecraft:hanging_roots", "chance": 0.3 },
    { "item": "minecraft:mangrove_roots", "chance": 0.3 },
    { "item": "minecraft:kelp", "chance": 0.3 },
    { "item": "minecraft:leaves", "chance": 0.3 },
    { "item": "minecraft:leaves2", "chance": 0.3 },
    { "item": "minecraft:mangrove_leaves", "chance": 0.3 },
    { "item": "minecraft:cherry_leaves", "chance": 0.3 },
    { "item": "minecraft:azalea_leaves", "chance": 0.3 },
    { "item": "minecraft:melon_seeds", "chance": 0.3 },
    { "item": "minecraft:moss_carpet", "chance": 0.3 },
    { "item": "minecraft:pink_petals", "chance": 0.3 },
    { "item": "minecraft:pitcher_pod", "chance": 0.3 },
    { "item": "minecraft:pumpkin_seeds", "chance": 0.3 },
    { "item": "minecraft:sapling", "chance": 0.3 },
    { "item": "minecraft:cherry_sapling", "chance": 0.3 },
    { "item": "minecraft:seagrass", "chance": 0.3 },
    { "item": "minecraft:small_dripleaf_block", "chance": 0.3 },
    { "item": "minecraft:sweet_berries", "chance": 0.3 },
    { "item": "minecraft:torchflower_seeds", "chance": 0.3 },
    { "item": "minecraft:wheat_seeds", "chance": 0.3 },
    { "item": "minecraft:cactus", "chance": 0.5 },
    { "item": "minecraft:dried_kelp_block", "chance": 0.5 },
    { "item": "minecraft:azalea_leaves_flowered", "chance": 0.5 },
    { "item": "minecraft:glow_lichen", "chance": 0.5 },
    { "item": "minecraft:melon_slice", "chance": 0.5 },
    { "item": "minecraft:nether_sprouts", "chance": 0.5 },
    { "item": "minecraft:sugar_cane", "chance": 0.5 },
    // { "item": "minecraft:tall_grass", "chance": 0.5 }, Here go the Tall Grass, according to the wiki. But for now it's data of "minecraft:double_plant", so dropping it in a composter will compost with a chance of 65% (prioritizing double flowers) and not 50%. Waiting for mojang to give it a unique identifier :/
    { "item": "minecraft:twisting_vines", "chance": 0.5 },
    { "item": "minecraft:vine", "chance": 0.5 },
    { "item": "minecraft:weeping_vines", "chance": 0.5 },
    { "item": "minecraft:apple", "chance": 0.65 },
    { "item": "minecraft:azalea", "chance": 0.65 },
    { "item": "minecraft:beetroot", "chance": 0.65 },
    { "item": "minecraft:big_dripleaf", "chance": 0.65 },
    { "item": "minecraft:carrot", "chance": 0.65 },
    { "item": "minecraft:cocoa_beans", "chance": 0.65 },
    { "item": "minecraft:yellow_flower", "chance": 0.65 },
    { "item": "minecraft:red_flower", "chance": 0.65 },
    { "item": "minecraft:double_plant", "chance": 0.65 }, // Sadly includes the Tall Grass, which should compost in a chance of 50% instead.
    { "item": "minecraft:crimson_fungus", "chance": 0.65 },
    { "item": "minecraft:warped_fungus", "chance": 0.65 },
    { "item": "minecraft:waterlily", "chance": 0.65 },
    { "item": "minecraft:melon_block", "chance": 0.65 },
    { "item": "minecraft:moss_block", "chance": 0.65 },
    { "item": "minecraft:brown_mushroom", "chance": 0.65 },
    { "item": "minecraft:red_mushroom", "chance": 0.65 },
    // { "item": "minecraft:mushroom_stem", "chance": 0.85 }, Here go the Mushroom Stem, according to the wiki. But for now it's data of "minecraft:brown_mushroom_block" and "minecraft:red_mushroom_block", so dropping it in a composter will compost with a chance of 85% (prioritizing mushroom blocks) and not 65%. Waiting for mojang to give it a unique identifier :/
    { "item": "minecraft:nether_wart", "chance": 0.65 },
    { "item": "minecraft:potato", "chance": 0.65 },
    { "item": "minecraft:pumpkin", "chance": 0.65 },
    { "item": "minecraft:carved_pumpkin", "chance": 0.65 },
    { "item": "minecraft:crimson_roots", "chance": 0.65 },
    { "item": "minecraft:warped_roots", "chance": 0.65 },
    { "item": "minecraft:sea_pickle", "chance": 0.65 },
    { "item": "minecraft:shroomlight", "chance": 0.65 },
    { "item": "minecraft:spore_blossom", "chance": 0.65 },
    { "item": "minecraft:wheat", "chance": 0.65 },
    { "item": "minecraft:baked_potato", "chance": 0.85 },
    { "item": "minecraft:bread", "chance": 0.85 },
    { "item": "minecraft:cookie", "chance": 0.85 },
    { "item": "minecraft:flowering_azalea", "chance": 0.85 },
    { "item": "minecraft:hay_block", "chance": 0.85 },
    { "item": "minecraft:brown_mushroom_block", "chance": 0.85 }, // Sadly includes the Stem, which should compost in a chance of 65% instead.
    { "item": "minecraft:red_mushroom_block", "chance": 0.85 }, // Sadly includes the Stem, which should compost in a chance of 65% instead.
    { "item": "minecraft:nether_wart_block", "chance": 0.85 },
    { "item": "minecraft:pitcher_plant", "chance": 0.85 },
    { "item": "minecraft:torchflower", "chance": 0.85 },
    { "item": "minecraft:warped_wart_block", "chance": 0.85 },
    { "item": "minecraft:cake", "chance": 1.0 },
    { "item": "minecraft:pumpkin_pie", "chance": 1.0 }
  ]
  static getCompostable(item) {
    return this.registerCompostables[this.registerCompostables.findIndex(compostable => item === compostable.item)];
  }
  static getVanillaCompostable(item) {
    return this.vanillaCompostables[this.vanillaCompostables.findIndex(compostable => item === compostable.item)];
  }
  static isCompostable(block) {
    return block.permutation.getState('composter_fill_level') < 7;
  }
  static composting(composter, chance, hopper = false) {
    let composterFillLevel = composter.permutation.getState('composter_fill_level');
    if (Math.random() < chance || composterFillLevel <= 0) {
      composter.setPermutation(composter.permutation.withState('composter_fill_level', ++composterFillLevel));
      if (composterFillLevel === 7) {
        system.runTimeout(() => {
          if (!composter?.isValid() || composter.permutation.getState('composter_fill_level') != composterFillLevel) return;
          composter.setPermutation(composter.permutation.withState('composter_fill_level', 8));
          world.playSound('block.composter.ready', composter.center());
        }, 20);
      }
      world.playSound('block.composter.fill_success', composter.center());
    } else {
      world.playSound('block.composter.fill', composter.center());
    }
    if (hopper) return;
    world.playSound('item.bone_meal.use', composter.center(), {pitch: Math.random() * (1.1 - 0.9) + 0.9});
    composter.dimension.spawnParticle('minecraft:crop_growth_emitter', composter.center());
  }
  static decrementStack(player) {
    if (player.matches({gameMode:'creative'})) return;
    const equippable = player.getComponent('equippable');
    const item = equippable.getEquipment('Mainhand');
    const stack = item.amount;
    if (stack > 1) --item.amount;
    equippable.setEquipment('Mainhand', stack > 1 ? item : null);
  }
}

world.beforeEvents.itemUseOn.subscribe(data => {
  const compostable = Compostables.getCompostable(data.itemStack?.typeId);
  if (compostable && Compostables.isCompostable(data.block) && !data.source?.isSneaking) {
    system.run(() => {
      Compostables.composting(data.block, compostable.chance);
      Compostables.decrementStack(data.source);
    });
  }
});

// Compost-by-dropping system

let compostByDropping = world?.getDynamicProperty('jlmcpe.compostables:compostByDropping') !== false;

world.afterEvents.entitySpawn.subscribe(data => {
  if (data.entity?.typeId === 'minecraft:item' && compostByDropping) {
    const item = data.entity;
    const itemStack = item?.getComponent('item')?.itemStack;
    const compostable = Compostables.getCompostable(itemStack.typeId) ?? Compostables.getVanillaCompostable(itemStack.typeId);
    if (!compostable) return;
    const fallingItem = system.runInterval(() => {
      if (!item?.isValid() || !compostByDropping) return system.clearRun(fallingItem);
      if (!item.isFalling) {
        const block = item.dimension.getBlock(item.location);
        let stackAmount = itemStack.amount;
        if (Compostables.isCompostable(block)) {
          for (; stackAmount > 0; stackAmount--) {
            if (!Compostables.isCompostable(block)) break;
            if (stackAmount > 1) --itemStack.amount;
            Compostables.composting(block, compostable.chance);
          }
          if (stackAmount > 0) item.dimension.spawnItem(itemStack, item.location);
          item.remove();
        } else if (block.permutation.matches('minecraft:composter') || block.below().permutation.matches('minecraft:composter')) return;
        system.clearRun(fallingItem);
      }
    }, 5);
  }
});

system.afterEvents.scriptEventReceive.subscribe(event => {
  if (event.id !== 'jlmcpe.compostables:compostByDropping') return;
  if (!compostByDropping) {
    world.setDynamicProperty('jlmcpe.compostables:compostByDropping');
  } else world.setDynamicProperty('jlmcpe.compostables:compostByDropping', false);
	compostByDropping = !compostByDropping;
});

// Hoppers system

let hopperTicking;

class HopperRegistry {
	constructor(dimension, location) {
		this.dimension = dimension.id;
		this.location = location;
	}
	static registries = new Set();
	static getRegistries() {
		const ids = world.getDynamicPropertyIds(), len = ids.length;
		for (let i = 0; i < len; i++) {
			const id = ids[i];
			if (id.startsWith('jlmcpe.compostables:hopper')) this.registries.add(world.getDynamicProperty(id));
		}
		if (this.registries.size) this.hopperTicking();
	}
	static add(registry) {
		registry = JSON.stringify(registry);
		if (this.registries.has(registry)) return;
		const id = 'jlmcpe.compostables:hopper_' + this.registries.size;
		world.setDynamicProperty(id, registry);
		if (!this.registries.size) this.hopperTicking();
		this.registries.add(registry);
	}
	static remove(registry) {
		const registryIds = [], ids = world.getDynamicPropertyIds();
		for (let i = 0; i < ids.length; i++) {
			const id = ids[i];
			if (id.startsWith('jlmcpe.compostables:hopper')) registryIds.push(id);
		}
		this.registries.delete(registry);
		registryIds.sort((a, b) => a.y - b.y);
		world.setDynamicProperty(registryIds[registryIds.length - 1], null);
		const registries = Array.from(HopperRegistry.registries);
		for (let i = 0; i < registryIds.length; i++) {
			const id = 'jlmcpe.compostables:hopper_' + i;
			world.setDynamicProperty(id, registries[i]);
		}
		if (!registries.length) system.clearRun(hopperTicking);
	}
	static getCompostingHopper(block) {
		if (block.permutation.matches('minecraft:hopper', { facing_direction: 0 }) && block.below().permutation.matches('minecraft:composter')) return block;
		const blockAbove = block.above();
		if (block.permutation.matches('minecraft:composter') && blockAbove.permutation.matches('minecraft:hopper', { facing_direction: 0 })) return blockAbove;
	}
	static getOutputComposter(hopper) {
		const hopperBelow = hopper.below();
		if (hopper.permutation.matches('minecraft:hopper', { facing_direction: 0 }) && hopperBelow.permutation.matches('minecraft:composter')) return hopperBelow;
	}
  static hopperTick() {
		const registries = Array.from(HopperRegistry.registries);
		for (let i = registries.length; i--;) {
			const registry = registries[i];
			const hopperData = JSON.parse(registry);
      const hopper = world.getDimension(hopperData.dimension).getBlock(hopperData.location);
      if (!hopper?.isValid()) continue;
			const composter = HopperRegistry.getOutputComposter(hopper);
      if (!composter) {
        system.run(() => HopperRegistry.remove(registry));
        continue;
      }
      if (hopper.permutation.matches('minecraft:hopper', {toggle_bit: true})) continue;
      const hopperContainer = hopper.getComponent('inventory').container;
      if (hopperContainer.emptySlotsCount === hopperContainer.size) continue;
      const hasVanillaCompostable = () => {
        let slot = hopperContainer.size;
        while (slot--) {
          const item = hopperContainer.getItem(slot);
          if (item && Compostables.getVanillaCompostable(item.typeId)) return true;
        }
      }
      if (hasVanillaCompostable()) continue;
      for (let slot = 0; slot < hopperContainer.size; slot++) {
        const item = hopperContainer.getItem(slot);
        if (!item) continue;
        const compostable = Compostables.getCompostable(item.typeId);
        if (!Compostables.isCompostable(composter) || !compostable) continue;
        const stack = item.amount;
        if (stack > 1) --item.amount;
        hopperContainer.setItem(slot, stack > 1 ? item : null);
        Compostables.composting(composter, compostable.chance, true);
        break;
      }
    }
  }
  static hopperTicking() {
    hopperTicking = system.runInterval(this.hopperTick, 8);
  }
}

// Initialize
system.run(() => {
	HopperRegistry.getRegistries();
});

world.afterEvents.playerPlaceBlock.subscribe(data => {
  if (HopperRegistry.getCompostingHopper(data.block)) {
    HopperRegistry.add(new HopperRegistry(data.dimension, HopperRegistry.getCompostingHopper(data.block)));
  }
}, {blockTypes: ['minecraft:composter', 'minecraft:hopper']});

// Piston Updater

class Vec3 {
	constructor(x, y, z) {
		this.x = x;
		this.y = y;
		this.z = z;
	}
}

world.afterEvents.pistonActivate.subscribe(data => {
	const { piston } = data, state = piston.state;
	const direction = data.block.permutation.getState('facing_direction');
	const movedBlocks = piston.getAttachedBlocks();
	system.runTimeout(() => {
		for (let i = movedBlocks.length; i--;) {
			const movedBlock = movedBlocks[i];
			const newLocation = {
				0: { Expanding: new Vec3(0, -1, 0), Retracting: new Vec3(0, 1, 0) },
				1: { Expanding: new Vec3(0, 1, 0), Retracting: new Vec3(0, -1, 0) },
				2: { Expanding: new Vec3(0, 0, 1), Retracting: new Vec3(0, 0, -1) },
				3: { Expanding: new Vec3(0, 0, -1), Retracting: new Vec3(0, 0, 1) },
				4: { Expanding: new Vec3(1, 0, 0), Retracting: new Vec3(-1, 0, 0) },
				5: { Expanding: new Vec3(-1, 0, 0), Retracting: new Vec3(1, 0, 0) }
			}[direction][state];
			const block = movedBlock?.offset(newLocation);
			if (!block?.isValid()) continue;
			const compostingHopper = HopperRegistry.getCompostingHopper(block);
      if (compostingHopper) {
        HopperRegistry.add(new HopperRegistry(compostingHopper.dimension, compostingHopper.location));
      }
		}
	}, 2);
});


/* © 2019-2024, <@JeanLucasMCPE> - All Rights Reserved. */